-- DurabilityInfosWindow.lua
-- Written by Habna


SlotsBG = {"0x41007eed", "0x41007ef6", "0x41007ef7", "0x41007eef", "0x41007eee", "0x41007ee9", "0x41007ef0", "0x41007ef9", "0x41007ef8",
		"0x41007ef4", "0x41007ef3", "0x41007ef2", "0x41007ef1", "0x41007ef5", "0x41007efa", "0x41007eea", "0x41007eeb", "0x41007eec",
		"0x41007efb", "0x410e8680"};

SlotsText = {L["EWST1"], L["EWST2"], L["EWST3"], L["EWST4"], L["EWST5"], L["EWST6"], L["EWST7"], L["EWST8"], L["EWST9"],
		L["EWST10"], L["EWST11"], L["EWST12"], L["EWST13"], L["EWST14"], L["EWST15"], L["EWST16"], L["EWST17"],	L["EWST18"],
		L["EWST19"], L["EWST20"]};


function frmDurabilityInfosWindow()
	wDurabilityInfos = Turbine.UI.Lotro.Window();
	--wDurabilityInfos = Turbine.UI.Lotro.GoldWindow();
	frmDI = true;
	wDurabilityInfos:SetSize( 390, 440 );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = wDurabilityInfos:GetSize();
	local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight / 2 );
    wDurabilityInfos:SetPosition( left, top );
	wDurabilityInfos:SetText( L["DWTitle"] );
	wDurabilityInfos:SetVisible( true );
	wDurabilityInfos:SetWantsKeyEvents( true );
	--wDurabilityInfos:SetZOrder( 2 );
	wDurabilityInfos:Activate();

	wDurabilityInfos.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wDurabilityInfos:Close();
		elseif ( args.Action == 268435635 ) then -- **v Hide wBackground if F12 key is press v**
			wDurabilityInfos:SetVisible( not wDurabilityInfos:IsVisible() );
		end
	end

	wDurabilityInfos.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then DIRefreshListBox(); end
	end

	wDurabilityInfos.Closing = function( sender, args )
		frmDI = nil;
		wDurabilityInfos = nil;
	end

	lblBackPack = Turbine.UI.Label();
	lblBackPack:SetParent( wDurabilityInfos );
	lblBackPack:SetText( L["DWLbl"] );
	lblBackPack:SetPosition( 15, 30);
	lblBackPack:SetSize( 350 , 35 );
	lblBackPack:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblBackPack:SetForeColor( Color["green"] );

	ListBoxBorder = Turbine.UI.Control();
	ListBoxBorder:SetParent( wDurabilityInfos );
	ListBoxBorder:SetPosition( lblBackPack:GetLeft() - 2, lblBackPack:GetHeight() + 25 );
	ListBoxBorder:SetSize( 354, 354 );
	ListBoxBorder:SetBackColor( Color["grey"] );
	ListBoxBorder:SetVisible( true );

	ListBox = Turbine.UI.ListBox();
	ListBox:SetParent( wDurabilityInfos );
	ListBox:SetPosition( ListBoxBorder:GetLeft() + 2, ListBoxBorder:GetTop() + 2 );
	ListBox:SetSize( ListBoxBorder:GetWidth() - 4, ListBoxBorder:GetHeight() - 4 );
	ListBox:SetMaxItemsPerLine( 3 );
	ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	ListBox:SetBackColor( Color["black"] );

	ScrollBar = Turbine.UI.Lotro.ScrollBar();
	ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	ScrollBar:SetParent( wDurabilityInfos );
	ScrollBar:SetPosition( ListBoxBorder:GetWidth() + 15, ListBoxBorder:GetTop() );
	ScrollBar:SetHeight( ListBoxBorder:GetHeight() );
	ScrollBar:SetWidth( 10 );
	ListBox:SetVerticalScrollBar( ScrollBar );
	
	DIRefreshListBox();
end

function DIRefreshListBox()
	--local PlayerEquipment = Player:GetEquipment();
	
	local DIitemCtl = {};
	local DIitemEquipment = {};
	local DIitemLbl = {};
	local DIitemLblScore = {};
	ListBox:ClearItems();
	
	for i = 1, 20 do
		-- Item control background
		DIitemCtl[i] = Turbine.UI.Control();
		DIitemCtl[i]:SetSize( 44, 44 );
		DIitemCtl[i]:SetBackground( tonumber(SlotsBG[i]) );
		DIitemCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- Item
		DIitemEquipment[i] = itemEquip[i];
		DIitemEquipment[i]:SetPosition( 3, 3 );
		DIitemEquipment[i]:SetParent( DIitemCtl[i] );
		
		-- Item name
		DIitemLbl[i] = Turbine.UI.Label();
		DIitemLbl[i]:SetSize( ListBox:GetWidth() - DIitemCtl[i]:GetWidth() - 30, DIitemCtl[i]:GetHeight() );
		DIitemLbl[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
		DIitemLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		--DIitemLbl[i]:SetForeColor( Color["white"] );
		
		if itemEquip[i].Item == false then 
			DIitemLbl[i]:SetForeColor( Color["red"] );
			DIitemLbl[i]:SetText( SlotsText[i] .. ":\n" .. L["EWItemNP"] );
		else
			DIitemLbl[i]:SetText( SlotsText[i] .. ":\n" .. itemEquip[i].Name );
		end

		-- Item Durability
		DIitemLblScore[i] = Turbine.UI.Label();
		DIitemLblScore[i]:SetText( itemEquip[i].ItemDurPts .. "%" );
		DIitemLblScore[i]:SetSize( 30, DIitemCtl[i]:GetHeight() );
		DIitemLblScore[i]:SetFont( Turbine.UI.Lotro.Font.TrajanPro12 );
		DIitemLblScore[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		
		-- Show item
		ListBox:AddItem( DIitemCtl[i] );
		ListBox:AddItem( DIitemLbl[i] );
		ListBox:AddItem( DIitemLblScore[i] );
	end
end