-- MoneyInfosWindow.lua
-- written by Habna


function frmMoneyInfosWindow()
	frmMI = true;

	wMoneyInfos = Turbine.UI.Lotro.Window()
	--wMoneyInfos = Turbine.UI.Lotro.GoldWindow()
	
	-- **v Set backcolor, position, size and text of the window v**
	wMoneyInfos:SetText( L["MIWTitle"] );
	wMoneyInfos:SetWantsKeyEvents( true );
	wMoneyInfos:SetVisible( true );
	wMoneyInfos:SetZOrder( 2 );
	wMoneyInfos:Activate();
	-- **^

	wMoneyInfos.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wMoneyInfos:Close();
		elseif ( args.Action == 268435635 ) then -- **v Hide wMoneyInfos if F12 key is press v**
			wMoneyInfos:SetVisible( not wMoneyInfos:IsVisible() );
		end
	end

	wMoneyInfos.Closing = function( sender, args ) -- Function for the Upper right X icon
		wMoneyInfos = nil;
		frmMI = nil;
	end
	
	local vWallet_Name, vWallet_Money, i, PosX, PosY = {}, {}, 1, 40, 35;
	local GoldTot, SilverTot, CopperTot = 0, 0, 0;
	
	for k,v in pairs(wallet) do
		vWallet_Name[i] = k;
		vWallet_Money[i] = v;
		i = i + 1;
	end
	
	for i = 1, #vWallet_Name do
		--**v Control of Gold/Silver/Copper currencies v**
		local MoneyCtr = Turbine.UI.Control();
		MoneyCtr:SetParent( wMoneyInfos );
		MoneyCtr:SetPosition( PosX, PosY );
		MoneyCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		--MoneyCtr:SetBackColor( Color["red"] ); -- Debug purpose
		--**^
		--**v Player name v**
		local lblName = Turbine.UI.Label();
		lblName:SetParent( MoneyCtr );
		--lblName:SetFont ( 12 );
		lblName:SetText( vWallet_Name[i] );
		lblName:SetPosition( 0, 0 );
		lblName:SetSize( string.len(lblName:GetText()) * 7.5, 30 );
		lblName:SetForeColor( Color["green"] );
		lblName:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		--lblName:SetBackColor( Color["red"] ); -- debug purpose
		--**^

		-- Find and extract amount
		local args = vWallet_Money[i];
		local pos1 = string.find(args, "/", 0);
		local pos2 = string.find(args, "/", pos1 + 1);

		local Gold = string.sub(args, 1, pos1 - 1);
		GoldTot = GoldTot + Gold;
		local Silver = string.sub(args, pos1 + 1, pos2 - 1);
		SilverTot = SilverTot + Silver;
		local Copper = string.sub(args, pos2 + 1, string.len(args));
		CopperTot = CopperTot + Copper;		
		--

		--**v Gold icon & amount v**
		local GoldLbl = Turbine.UI.Label();
		GoldLbl:SetParent( MoneyCtr );
		--GoldLbl:SetForeColor( Color["white"] );
		GoldLbl:SetPosition( lblName:GetLeft() + lblName:GetWidth() + 5, 0 );
		GoldLbl:SetText( Gold );
		GoldLbl:SetSize( string.len(GoldLbl:GetText()) * 7.5, 30 );
		GoldLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
		GoldLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
		--GoldLbl:SetBackColor( Color["white"] ); -- Debug purpose

		local GoldIcon = Turbine.UI.Control();
		GoldIcon:SetParent( MoneyCtr );
		GoldIcon:SetPosition( GoldLbl:GetLeft() + GoldLbl:GetWidth() + 2, 4 );
		GoldIcon:SetSize( 27, 21 );
		GoldIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		GoldIcon:SetBackground( 0x41007e7b ); -- in-game gold icon
		--GoldIcon:SetBackColor( Color["blue"] ); -- Debug purpose
		--**^
		--**v Silver icon & amount v**
		local SilverLbl = Turbine.UI.Label();
		SilverLbl:SetParent( MoneyCtr );
		--SilverLbl:SetForeColor( Color["white"] );
		SilverLbl:SetPosition( GoldIcon:GetLeft() + GoldIcon:GetWidth() + 5, 0 );
		SilverLbl:SetText( Silver );
		SilverLbl:SetSize( string.len(SilverLbl:GetText()) * 7.5, 30 );
		SilverLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
		SilverLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
		--SilverLbl:SetBackColor( Color["white"] ); -- Debug purpose

		local SilverIcon = Turbine.UI.Control();
		SilverIcon:SetParent( MoneyCtr );
		SilverIcon:SetPosition( SilverLbl:GetLeft() + SilverLbl:GetWidth() + 2, 4 );
		SilverIcon:SetSize( 27, 21 );
		SilverIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		SilverIcon:SetBackground( 0x41007e7c ); -- in-game silver icon
		--SilverIcon:SetBackColor( Color["blue"] ); -- Debug purpose
		--**^
		--**v Copper icon & amount v**
		local CopperLbl = Turbine.UI.Label();
		CopperLbl:SetParent( MoneyCtr );
		--CopperLbl:SetForeColor( Color["white"] );
		CopperLbl:SetPosition( SilverIcon:GetLeft() + SilverIcon:GetWidth() + 5, 0 );
		CopperLbl:SetText( Copper );
		CopperLbl:SetSize( string.len(CopperLbl:GetText()) * 7.5, 30 );
		CopperLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
		CopperLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
		--CopperLbl:SetBackColor( Color["white"] ); -- Debug purpose

		local CopperIcon = Turbine.UI.Control();
		CopperIcon:SetParent( MoneyCtr );
		CopperIcon:SetPosition( CopperLbl:GetLeft() + CopperLbl:GetWidth() + 2, 4 );
		CopperIcon:SetSize( 27, 21 );
		CopperIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		CopperIcon:SetBackground( 0x41007e7d ); -- in-game copper icon
		--CopperIcon:SetBackColor( Color["blue"] ); -- Debug purpose
		--**^

		MoneyCtr:SetSize( lblName:GetWidth() + GoldLbl:GetWidth() + GoldIcon:GetWidth() + SilverLbl:GetWidth() + SilverIcon:GetWidth() + CopperLbl:GetWidth() + CopperIcon:GetWidth() + 21, 30 );
		
		PosY = PosY + 20;
		--wMoneyInfos:SetSize( MoneyCtr:GetWidth() + 80, PosY );
	end

	PosY = PosY + 5;

	--**v Control of total Gold/Silver/Copper v**
	local TotMoneyCtr = Turbine.UI.Control();
	TotMoneyCtr:SetParent( wMoneyInfos );
	TotMoneyCtr:SetPosition( PosX, PosY );
	TotMoneyCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--TotMoneyCtr:SetBackColor( Color["red"] ); -- Debug purpose
	--**^
	--**v Total label v**
	local TotLbl = Turbine.UI.Label();
	TotLbl:SetParent( TotMoneyCtr );
	--TotLbl:SetFont ( 12 );
	TotLbl:SetText( L["MIWTotal"] );
	TotLbl:SetPosition( 0, 0 );
	TotLbl:SetSize( string.len(TotLbl:GetText()) * 7.5, 30 );
	TotLbl:SetForeColor( Color["green"] );
	TotLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--TotLbl:SetBackColor( Color["red"] ); -- debug purpose
	--**^
	--**v Gold icon & amount v**
	local GoldLbl = Turbine.UI.Label();
	GoldLbl:SetParent( TotMoneyCtr );
	--GoldLbl:SetForeColor( Color["white"] );
	GoldLbl:SetPosition( TotLbl:GetLeft() + TotLbl:GetWidth() + 5, 0 );
	GoldLbl:SetText( GoldTot );
	GoldLbl:SetSize( string.len(GoldLbl:GetText()) * 7.5, 30 );
	GoldLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	GoldLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--GoldLbl:SetBackColor( Color["white"] ); -- Debug purpose

	local GoldIcon = Turbine.UI.Control();
	GoldIcon:SetParent( TotMoneyCtr );
	GoldIcon:SetPosition( GoldLbl:GetLeft() + GoldLbl:GetWidth() + 2, 4 );
	GoldIcon:SetSize( 27, 21 );
	GoldIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	GoldIcon:SetBackground( 0x41007e7b ); -- in-game gold icon
	--GoldIcon:SetBackColor( Color["blue"] ); -- Debug purpose
	--**^
	--**v Silver icon & amount v**
	local SilverLbl = Turbine.UI.Label();
	SilverLbl:SetParent( TotMoneyCtr );
	--SilverLbl:SetForeColor( Color["white"] );
	SilverLbl:SetPosition( GoldIcon:GetLeft() + GoldIcon:GetWidth() + 5, 0 );
	SilverLbl:SetText( SilverTot );
	SilverLbl:SetSize( string.len(SilverLbl:GetText()) * 7.5, 30 );
	SilverLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	SilverLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--SilverLbl:SetBackColor( Color["white"] ); -- Debug purpose

	local SilverIcon = Turbine.UI.Control();
	SilverIcon:SetParent( TotMoneyCtr );
	SilverIcon:SetPosition( SilverLbl:GetLeft() + SilverLbl:GetWidth() + 2, 4 );
	SilverIcon:SetSize( 27, 21 );
	SilverIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	SilverIcon:SetBackground( 0x41007e7c ); -- in-game silver icon
	--SilverIcon:SetBackColor( Color["blue"] ); -- Debug purpose
	--**^
	--**v Copper icon & amount v**
	local CopperLbl = Turbine.UI.Label();
	CopperLbl:SetParent( TotMoneyCtr );
	--CopperLbl:SetForeColor( Color["white"] );
	CopperLbl:SetPosition( SilverIcon:GetLeft() + SilverIcon:GetWidth() + 5, 0 );
	CopperLbl:SetText( CopperTot );
	CopperLbl:SetSize( string.len(CopperLbl:GetText()) * 7.5, 30 );
	CopperLbl:SetFontStyle( Turbine.UI.FontStyle.Outline );
	CopperLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
	--CopperLbl:SetBackColor( Color["white"] ); -- Debug purpose

	local CopperIcon = Turbine.UI.Control();
	CopperIcon:SetParent( TotMoneyCtr );
	CopperIcon:SetPosition( CopperLbl:GetLeft() + CopperLbl:GetWidth() + 2, 4 );
	CopperIcon:SetSize( 27, 21 );
	CopperIcon:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	CopperIcon:SetBackground( 0x41007e7d ); -- in-game copper icon
	--CopperIcon:SetBackColor( Color["blue"] ); -- Debug purpose
	--**^

	TotMoneyCtr:SetSize( TotLbl:GetWidth() + GoldLbl:GetWidth() + GoldIcon:GetWidth() + SilverLbl:GetWidth() + SilverIcon:GetWidth() + CopperLbl:GetWidth() + CopperIcon:GetWidth() + 21, 30 );
	
	wMoneyInfos:SetSize( TotMoneyCtr:GetWidth() + 80, PosY + 40 );
	
	local winWidth, winHeight = wMoneyInfos:GetSize();
	local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight /2 )
    wMoneyInfos:SetPosition( left, top );
	--**^
end