-- frmMain.lua
-- written by Habna


resources = {
	--TitanBar = { Background = AppRes.."background.tga" },

	LeftBubble_TopLeftCorner = { Background = AppRes.."lbubble_top_left_corner.tga" },
	LeftBubble_TopRightCorner = { Background = AppRes.."lbubble_top_right_corner.tga" },
	Bubble_MidLeft = { Background = AppRes.."bubble_mid_left.tga" },
	Bubble_BotLeftCorner = { Background = AppRes.."bubble_bot_left_corner.tga" },
	Bubble_Top = { Background = AppRes.."bubble_top.tga" },
	Bubble_Bot = { Background = AppRes.."bubble_bot.tga" },
	Bubble_Mid = { Background = AppRes.."bubble_mid.tga" },
	Bubble_MidRight = { Background = AppRes.."bubble_mid_right.tga" },
	Bubble_BotRightCorner = { Background = AppRes.."bubble_bot_right_corner.tga" },

	RightBubble_TopLeftCorner = { Background = AppRes.."rbubble_top_left_corner.tga" },
	RightBubble_TopRightCorner = { Background = AppRes.."rbubble_top_right_corner.tga" },

	Ring = { Background = AppRes.."ring.tga" },
	Picker = { Background = AppRes.."picker.jpg" },

	RuneKeeper = { Background = AppRes.."runekeeper.tga" }, -- Removed when found in-game icon
	Warden = { Background = AppRes.."warden.tga" } -- Removed when found in-game icon
};

function frmMain()
	--**v Check if TitanBar Reloader is loaded v**
	Turbine.PluginManager.RefreshAvailablePlugins();
	loaded_plugins = Turbine.PluginManager.GetLoadedPlugins();

	TBRChecker = Turbine.UI.Control();
	TBRChecker:SetWantsUpdates( true );
	
	TBRChecker.Update = function( sender, args )
		for k,v in pairs(loaded_plugins) do
			if v.Name == "TitanBar Reloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarReloader' );
				--break;
			end
			if v.Name == "TitanBar Unloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarUnloader' );
				--break;
			end
		end
		TBRChecker:SetWantsUpdates( false );
	end
	--**^

	ToolTipWin = nil;

	_G.TB = {};
	
	TB["win"] = Turbine.UI.Window();
	TB["win"]:SetPosition( 0, 0 );
	TB["win"]:SetSize( screenWidth, 30 );
	--TB["win"]:SetBackground( resources.TitanBar.Background );
	TB["win"]:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	--TB["win"]:SetMouseVisible( false ); -- If set to false, menu will not work.
	TB["win"]:SetWantsKeyEvents( true );
	--TB["win"]:SetZOrder( 10 );
	TB["win"]:SetVisible( true );

	--**v Get player backpack, Class, Race & attributes v**
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		Player = Turbine.Gameplay.LocalPlayer.GetInstance();
	else
		Player = Turbine.Gameplay.LocalPlayer;
	end
	-- Detect if it's monster play
	PlayerAlign = Player:GetAlignment(); --1 Free People / 2 Monster Play
	--
	--Client will crash if :GetAttributes is called and then the plugin is unloaded
	--PlayerAtt = Player:GetAttributes();
	--**^
	
	-- 0x41007f7a (Mail in game icon)

	-- 0x41007eca (Poor server connection)
	-- 0x41007ecb (Broken server connection)
	-- 0x41007ecc (Good server connection)

	
	--**v TitanBar event handlers v**
	TB["win"].KeyDown = function( sender, args )
		if ( args.Action == 268435635 ) then -- **v Hide TitanBar if F12 key is press v**
			TB["win"]:SetVisible( not TB["win"]:IsVisible() );
		end
	end

	TB["win"].MouseLeave = function( sender, args )
		if ToolTipWin ~= nil then
			ToolTipWin:SetVisible( false );
			ToolTipWin = nil;
		end
	end

	TB["win"].MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then
			mouseXPos, mouseYPos = Turbine.UI.Display.GetMousePosition();
			_G.sFromCtr = "TitanBar";
			TitanBarMenu:ShowMenu();
		elseif ( args.Button == Turbine.UI.MouseButton.Left ) then
			
		end
	end

	TB["win"].Unload = function( sender, args )
		SaveCharacterWallet();
	end
	--**^ Window event handlers ^**
	
	if ShowMoney then ImportCtr( "MI" ); end
	if ShowDestinyPoints then ImportCtr( "DP" ); end
	
	-- Workaround for the ItemRemoved that fire before the backpack was updated (Turnine API issue)
	ItemRemovedTimer = Turbine.UI.Control();
	
	ItemRemovedTimer.Update = function( sender, args )
		ItemRemovedTimer:SetWantsUpdates( false );
		UpdateBackpackInfos();
	end
	--
	
	if ShowBagInfos then ImportCtr( "BI" );	end
	if ShowPlayerInfos then ImportCtr( "PI" ); end
	if ShowDurabilityInfos or ShowEquipInfos then GetEquipmentInfos(); end
	if ShowDurabilityInfos then ImportCtr( "DI" ); end
	
	-- Workaround for the ItemUnEquipped that fire before the Equipment was updated (Turnine API issue)
	ItemUnEquippedTimer = Turbine.UI.Control();
	
	ItemUnEquippedTimer.Update = function( sender, args )
		ItemUnEquippedTimer:SetWantsUpdates( false );
		UpdateEquipsInfos();
		UpdateDurabilityInfos();
	end
	--

	if ShowEquipInfos then ImportCtr( "EI" ); end
		
	if ShowPlayerLoc then ImportCtr( "PL" ); end
	if ShowGameTime then ImportCtr( "GT" ); end
	

	OneTimer = Turbine.UI.Control();
	if ShowBagInfos or ShowEquipInfos or ShowDurabilityInfos then OneTimer:SetWantsUpdates( true ); NumSec = 0; end
		
	--Run these function at-starup only once, cause if TitanBar is loaded with in-game plugin manager some control does not update properly
	OneTimer.Update = function( sender, args )
		local currentdate = Turbine.Engine.GetDate();
		local currentsecond = currentdate.Second;
		
		if NumSec < 20 then -- Run for 20 secs.
			if (oldsecond ~= currentsecond) then
				if ShowBagInfos then UpdateBackpackInfos(); end
				if ShowDurabilityInfos or ShowEquipInfos then GetEquipmentInfos(); end
				if ShowEquipInfos then UpdateEquipsInfos();	end
				if ShowDurabilityInfos then UpdateDurabilityInfos(); end

				oldsecond = currentsecond;
				NumSec = NumSec + 1;
				ReplaceModuleLocation( "left" );
				--write("OneTimer: " .. NumSec .. " secs");
			end
		else
			OneTimer:SetWantsUpdates( false );
		end
	end
	--
	-- run these functions every second
	Timer = Turbine.UI.Control();
	Timer:SetWantsUpdates( true );
	
	Timer.Update = function( sender, args )
		local currentdate = Turbine.Engine.GetDate();
		local currentminute = currentdate.Minute;
		
		if (oldminute ~= currentminute) then
			if ShowGameTime then UpdateGameTime(); end -- Until i found the minute Changed event

			oldminute = currentminute;
		end
	end
	--
	ReplaceModuleLocation( "all" );
end
-- **^