-- functions.lua
-- Written By Habna


function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

--**v Create a ToolTip Window v**
function createToolTipWin( xOffset, yOffset, xSize, ySize, side, header, text1, text2, text3 )
	ToolTipWin = Turbine.UI.Window();
	ToolTipWin:SetSize( xSize, ySize );
	--ToolTipWin:SetBackColor( Color["red"] ); -- Debug purpose
	ToolTipWin:SetMouseVisible( false );
	ToolTipWin:SetZOrder( 15 );
	ToolTipWin.xOffset = xOffset;
	ToolTipWin.yOffset = yOffset;

	--**v Top left corner v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( ToolTipWin );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 15, 12 );
	if side == "left" then topLeftCorner:SetBackground( resources.LeftBubble_TopLeftCorner.Background );
	elseif side == "right" then	topLeftCorner:SetBackground( resources.RightBubble_TopLeftCorner.Background ); end
	--**^
	--**v Mid Left v**
	midLeft = Turbine.UI.Control();
	midLeft:SetParent( ToolTipWin );
	midLeft:SetPosition( 0, 12 );
	midLeft:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midLeft:SetBackground( resources.Bubble_MidLeft.Background );
	--**^
	--**v Bottom Left Corner v**
	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( ToolTipWin );
	botLeftCorner:SetPosition( 0, ToolTipWin:GetHeight() - 12 );
	botLeftCorner:SetSize( 15, 12 );
	botLeftCorner:SetBackground( resources.Bubble_BotLeftCorner.Background );
	--**^
	--**v Top v**
	TopBar = Turbine.UI.Control();
	TopBar:SetParent( ToolTipWin );
	TopBar:SetPosition( 15, 0 );
	TopBar:SetSize( ToolTipWin:GetWidth() - 15, 12 );
	TopBar:SetBackground( resources.Bubble_Top.Background );
	--**^
	--**v Middle v**
	MidMid = Turbine.UI.Control();
	MidMid:SetParent( ToolTipWin );
	MidMid:SetPosition( 15, 12 );
	MidMid:SetSize( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	MidMid:SetBackground( resources.Bubble_Mid.Background );
	--**^
	--**v Bottom v**
	BotBar = Turbine.UI.Control();
	BotBar:SetParent( ToolTipWin );
	BotBar:SetPosition( 15, ToolTipWin:GetHeight() - 12 );
	BotBar:SetSize( ToolTipWin:GetWidth() - 5, 12 );
	BotBar:SetBackground( resources.Bubble_Bot.Background );
	--**^
	--**v Top right corner v**
	topRightCorner = Turbine.UI.Control();
	topRightCorner:SetParent( ToolTipWin );
	topRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, 0 );
	topRightCorner:SetSize( 15, 12 );
	if side == "left" then topRightCorner:SetBackground( resources.LeftBubble_TopRightCorner.Background );
	elseif side == "right" then topRightCorner:SetBackground( resources.RightBubble_TopRightCorner.Background ); end
	--**^
	--**v Mid Right v**
	midRight = Turbine.UI.Control();
	midRight:SetParent( ToolTipWin );
	midRight:SetPosition( ToolTipWin:GetWidth() - 15, 12 );
	midRight:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midRight:SetBackground( resources.Bubble_MidRight.Background );
	--**^
	--**v Bottom right corner v**
	botRightCorner = Turbine.UI.Control();
	botRightCorner:SetParent( ToolTipWin );
	botRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	botRightCorner:SetSize( 15, 12 );
	botRightCorner:SetBackground( resources.Bubble_BotRightCorner.Background );
	--**^
	
	lblheader = Turbine.UI.Label();
	lblheader:SetParent( ToolTipWin );
	lblheader:SetPosition( 10, 10 );
	lblheader:SetSize( xSize, ySize );
	lblheader:SetForeColor( Color["blue"] );
	lblheader:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	lblheader:SetText( header );
	
	lbltext1 = Turbine.UI.Label();
	lbltext1:SetParent( ToolTipWin );
	lbltext1:SetPosition( 10, 25 );
	lbltext1:SetSize( xSize, 15 );
	lbltext1:SetForeColor( Color["black"] );
	lbltext1:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext1:SetText( text1 );

	lbltext2 = Turbine.UI.Label();
	lbltext2:SetParent( ToolTipWin );
	lbltext2:SetPosition( 10, 45 );
	lbltext2:SetSize( xSize, 15 );
	lbltext2:SetForeColor( Color["black"] );
	lbltext2:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext2:SetText( text2 );

	lbltext3 = Turbine.UI.Label();
	lbltext3:SetParent( ToolTipWin );
	lbltext3:SetPosition( 10, 60 );
	lbltext3:SetSize( xSize, 15 );
	lbltext3:SetForeColor( Color["white"] );
	lbltext3:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lbltext3:SetText( text3 );
	
	return ToolTipWin;
end

-- Legend
-- ( offsetX, offsetY, width, height, bubble side, header text, text1, text2, text3 )
function ShowToolTipWin( ToShow )
	if ToShow == "MoneyG" then TTW = createToolTipWin( 0, -17, string.len(L["MGh"]) * 7.5, 45, "left", L["MGh"], L["EIt1"] ); end -- Money infos Gold
	if ToShow == "MoneyS" then TTW = createToolTipWin( 0, -17, string.len(L["MSh"]) * 7.5, 45, "left", L["MSh"], L["EIt1"] ); end -- Money infos Silver
	if ToShow == "MoneyC" then TTW = createToolTipWin( 0, -17, string.len(L["MCh"]) * 7.5, 45, "left", L["MCh"], L["EIt1"] ); end -- Money infos Copper
	if ToShow == "DP" then TTW = createToolTipWin( 0, -19, string.len(L["DPh"]) * 7.5, 32, "left", L["DPh"] ); end -- Destiny points
	if ToShow == "Bag" then TTW = createToolTipWin( 0, -17, string.len(L["BIh"]) * 7.5, 45, "left", L["BIh"], L["BIt1"] ); end --Bag infos
	if ToShow == "PIcon" then  -- Player class
		local txt = L["PIICON"] .. PlayerRaceIs .. PlayerClassIs
		TTW = createToolTipWin( 0, -17, string.len(txt) * 8.2, 32, "left", txt );
	end
	if ToShow == "PLvl" then TTW = createToolTipWin( 0, -17, string.len(L["PILVL"]) * 8, 32, "left", L["PILVL"] ); end -- Player level
	if ToShow == "PName" then TTW = createToolTipWin( 0, -17, string.len(L["PINAME"]) * 8.3, 32, "left", L["PINAME"] ); end -- Player name
	if ToShow == "EI" then TTW = createToolTipWin( 0, -17, string.len(L["EIh"]) * 7.5, 45, "left", L["EIh"], L["EIt1"] ); end -- Equipment infos
	if ToShow == "DI" then TTW = createToolTipWin( 0, -17, string.len(L["DIh"]) * 7.2, 45, "left", L["DIh"], L["EIt1"] ); end -- Durability infos

	if ToShow == "PL" then TTW = createToolTipWin( string.len(L["PLh"]) * 8 - 17, -17, string.len(L["PLh"]) * 8, 32, "right", L["PLh"] ); end -- Player Location
	if ToShow == "GT" then TTW = createToolTipWin( string.len(L["GTh"]) * 7.5 - 17, -17, string.len(L["GTh"]) * 7.5, 32, "right", L["GTh"] ); end -- Game Time

	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	ToolTipWin:SetPosition( mouseX - ToolTipWin.xOffset, mouseY - ToolTipWin.yOffset);
	ToolTipWin:SetVisible( true );
end
--**^
--**v Update money on TitanBar v**
function UpdateMoney()
	local money = PlayerAtt:GetMoney();
	local cp = math.fmod( money, 100 ); -- Copper
	money = ( money - cp) / 100;
	local sp = math.fmod( money, 1000 ); -- Silver
	local gp = ( money - sp ) / 1000; -- Gold
	
	MI["GLbl"]:SetText( gp );
	MI["GLbl"]:SetPosition( 5, 0 );
	MI["GLbl"]:SetSize( string.len(MI["GLbl"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	MI["GIcon"]:SetPosition( MI["GLbl"]:GetLeft() + MI["GLbl"]:GetWidth(), 4 );

	MI["SLbl"]:SetText( sp );
	MI["SLbl"]:SetPosition( MI["GIcon"]:GetLeft() + MI["GIcon"]:GetWidth() + 5, 0 );
	MI["SLbl"]:SetSize( string.len(MI["SLbl"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	MI["SIcon"]:SetPosition( MI["SLbl"]:GetLeft() + MI["SLbl"]:GetWidth(), 4 );

	MI["CLbl"]:SetText( cp );
	MI["CLbl"]:SetPosition( MI["SIcon"]:GetLeft() + MI["SIcon"]:GetWidth() + 5, 0 );
	MI["CLbl"]:SetSize( string.len(MI["CLbl"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	MI["CIcon"]:SetPosition( MI["CLbl"]:GetLeft() + MI["CLbl"]:GetWidth(), 4 );
	
	MI["Ctr"]:SetSize( MI["GLbl"]:GetWidth() + MI["GIcon"]:GetWidth() + MI["SLbl"]:GetWidth() + MI["SIcon"]:GetWidth() + MI["CLbl"]:GetWidth() + MI["CIcon"]:GetWidth() + 15, TB["win"]:GetHeight() );

	SaveCharacterWallet();
end
--**^
--**v Update destiny point currencies on TitanBar v**
function UpdateDestinyPoints()
	DP["Lbl"]:SetText( PlayerAtt:GetDestinyPoints() );
	DP["Lbl"]:SetSize( string.len(DP["Lbl"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	DP["Icon"]:SetPosition( DP["Lbl"]:GetLeft() + DP["Lbl"]:GetWidth() + 2, 4 );

	DP["Ctr"]:SetSize( DP["Lbl"]:GetWidth() + DP["Icon"]:GetWidth() + 7, TB["win"]:GetHeight() );
end
--**^
--**v Update backpack infos on TitanBar v**
function UpdateBackpackInfos()
	local max = Backpack:GetSize();
	local freeslots = 0;

	for i = 1, max do
		if ( Backpack:GetItem( i ) == nil ) then freeslots = freeslots + 1; end
	end

	BI["Lbl"]:SetText( max - freeslots .. "/" .. max );

	BI["Ctr"]:SetSize( BI["Icon"]:GetWidth() + BI["Lbl"]:GetWidth() + 7, TB["win"]:GetHeight() );
end
--**^
--**v Update player infos on TitanBar v**
function UpdatePlayersInfos()
	PlayerRaceIs = Player:GetRace();

	--Free people race
	if PlayerRaceIs == 0 then PlayerRaceIs = ""; -- Undefined
	elseif PlayerRaceIs == 65 then PlayerRaceIs = L["Elf"];
	elseif PlayerRaceIs == 23 then PlayerRaceIs = L["Man"];
	elseif PlayerRaceIs == 73 then PlayerRaceIs = L["Dwarf"];
	elseif PlayerRaceIs == 81 then PlayerRaceIs = L["Hobbit"]; end

	--Monster play race
	if PlayerRaceIs == 7 then PlayerRaceIs = ""; end
	--write(tostring(PlayerRaceIs));

	PlayerClassIs = Player:GetClass();
	if PlayerClassIs == 23 then PlayerClassIs = L["Guardian"]; PlayerIconCodeIs = "0x41007dd8"; end
	if PlayerClassIs == 24 then PlayerClassIs = L["Captain"]; PlayerIconCodeIs = "0x41007dd7"; end
	if PlayerClassIs == 31 then PlayerClassIs = L["Minstrel"]; PlayerIconCodeIs = "0x41007dd6"; end
	if PlayerClassIs == 40 then PlayerClassIs = L["Burglar"]; PlayerIconCodeIs = "0x41007ddb"; end
	if PlayerClassIs == 162 then PlayerClassIs = L["Hunter"]; PlayerIconCodeIs = "0x41007dda"; end
	if PlayerClassIs == 172 then PlayerClassIs = L["Champion"]; PlayerIconCodeIs = "0x41007ddc"; end
	if PlayerClassIs == 185 then PlayerClassIs = L["Lore-Master"]; PlayerIconCodeIs = "0x41007dd9"; end
	if PlayerClassIs == 191 then PlayerClassIs = L["Ranger"]; PlayerIconCodeIs = "default"; end --???  Default icon code, need real one thought
	if PlayerClassIs == 193 then PlayerClassIs = L["Rune-Keeper"]; PlayerIconCodeIs = "runekeeper"; end --Using my icon, need in-game one thought
	if PlayerClassIs == 194 then PlayerClassIs = L["Warden"]; PlayerIconCodeIs = "warden"; end --Using my icon, need in-game one thought

	--Monster Play Class
	if PlayerClassIs == 71 then PlayerClassIs = L["Reaver"]; PlayerIconCodeIs = "0x41007ddd"; end
	if PlayerClassIs == 127 then PlayerClassIs = L["Weaver"]; PlayerIconCodeIs = "0x41007de0"; end
	if PlayerClassIs == 179 then PlayerClassIs = L["Blackarrow"]; PlayerIconCodeIs = "0x41007ddf"; end
	if PlayerClassIs == 52 then PlayerClassIs = L["Warleader"]; PlayerIconCodeIs = "0x41007dde"; end
	if PlayerClassIs == 126 then PlayerClassIs = L["Stalker"]; PlayerIconCodeIs = "0x41007de1"; end
	if PlayerClassIs == 128 then PlayerClassIs = L["Defiler"]; PlayerIconCodeIs = "0x41008500";  end --Using red eye icon, need in-game one thought

	-- 0x41008500 (red eye) 32x32
	
	if PlayerIconCodeIs == "default" then PI["Icon"]:SetBackground( resources.Ring.Background );
	elseif PlayerIconCodeIs == "runekeeper" then PI["Icon"]:SetBackground( resources.RuneKeeper.Background );
	elseif PlayerIconCodeIs == "warden" then PI["Icon"]:SetBackground( resources.Warden.Background );
	else PI["Icon"]:SetBackground( tonumber(PlayerIconCodeIs) ); end 
	
	PI["Name"]:SetText( Player:GetName() );
	PI["Name"]:SetSize( string.len(PI["Name"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	PI["Lvl"]:SetText( Player:GetLevel() );
	PI["Lvl"]:SetSize( string.len(PI["Lvl"]:GetText()) * 8, TB["win"]:GetHeight() ); --Auto size with text lenght
	PI["Name"]:SetPosition( PI["Lvl"]:GetLeft() + PI["Lvl"]:GetWidth() + 2, 0 );

	PI["Ctr"]:SetSize( PI["Icon"]:GetWidth() + PI["Lvl"]:GetWidth() + PI["Name"]:GetWidth() + 9, TB["win"]:GetHeight() );
end
--**^
--**v Update equipment infos on TitanBar v**
function UpdateEquipsInfos( sender, args )
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );

		-- Item Quality & Durability
		if PlayerEquipItem ~= nil then
			itemEquip[i].Quality = PlayerEquipItem:GetQuality();
			itemEquip[i].Durability = PlayerEquipItem:GetDurability();
		else
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
		end
	end

	CalculateAllItemsScore();

	EI["Lbl"]:SetText( itemTotScore );
	EI["Lbl"]:SetSize( string.len(EI["Lbl"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	EI["Lbl"]:SetPosition( EI["Icon"]:GetLeft() + EI["Icon"]:GetWidth() + 2, 0 );

	EI["Ctr"]:SetSize( EI["Icon"]:GetWidth() + EI["Lbl"]:GetWidth() + 7, TB["win"]:GetHeight() );

	if ShowDurabilityInfos then UpdateDurabilityInfos(); end
end
--**^

function ChangeItem(value, whattodo)
	--write("ok");
	-- Set new Quality & Durability in table
	--itemEquip[value].Quality = PlayerEquipment:GetItem( EquipSlots[Slots[value]] ):GetQuality();
	--itemEquip[value].Durability = PlayerEquipment:GetItem( EquipSlots[Slots[value]] ):GetDurability();

	--CalculateAllItemsScore();
	--UpdateEquipsInfos();
end

function ChangeWearState(value)
	-- Set new wear state in table
	itemEquip[value].WearState = PlayerEquipment:GetItem( EquipSlots[Slots[value]] ):GetWearState();

	CalculateAllItemsDurability();
	UpdateDurabilityInfos();
end

--**v Update Player Durability infos on TitanBar v**
function UpdateDurabilityInfos()
	--write( "TitanBar: Updating Durability infos");

	CalculateAllItemsDurability();

	--if itemsTotDurability == 100 then itemsTotDurability = string.format( "%.0f", itemsTotDurability );
	--else itemsTotDurability = string.format( "%.2f", itemsTotDurability ); end

	itemsTotDurability = string.format( "%.0f", itemsTotDurability );
	
	DI["Lbl"]:SetText( itemsTotDurability .. "%" );
	DI["Lbl"]:SetSize( string.len(DI["Lbl"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	DI["Lbl"]:SetPosition( DI["Icon"]:GetLeft() + DI["Icon"]:GetWidth() + 2, 0 );

	DI["Ctr"]:SetSize( DI["Icon"]:GetWidth() + DI["Lbl"]:GetWidth() + 7, TB["win"]:GetHeight() );
end
--**^

--**v Update Player Location on TitanBar v**
function UpdatePlayerLoc( value )
	--write( "TitanBar: Updating Player Location");

	PL["Lbl"]:SetText( value );
	PL["Lbl"]:SetSize( string.len(PL["Lbl"]:GetText()) * 7.2, TB["win"]:GetHeight() ); --Auto size with text lenght
	PL["Lbl"]:SetPosition( 5, 0 );

	PL["Ctr"]:SetSize( PL["Lbl"]:GetWidth() + 5, TB["win"]:GetHeight() );
end
--**^
--**v Update game time on TitanBar v**
function UpdateGameTime()
	--write( "TitanBar: Updating Game Time");
	local currentdate = Turbine.Engine.GetDate();
	local currenthour = currentdate.Hour;
	local currentminute = currentdate.Minute;
	
	if currentminute < 10 then currentminute = "0" .. currentminute; end
	
	GT["Lbl"]:SetText( currenthour .. ":" .. currentminute );
	GT["Lbl"]:SetSize( string.len(GT["Lbl"]:GetText()) * 8, TB["win"]:GetHeight() ); --Auto size with text lenght

	GT["Ctr"]:SetSize( GT["Lbl"]:GetWidth() + 5, TB["win"]:GetHeight() );
end
--**^

-- **v Change TitanBar back color v**
function ChangeColor()
	if SetToAll then
		TB["win"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) );
		if ShowMoney then MI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDestinyPoints then DP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowBagInfos then BI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowPlayerInfos then PI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowEquipInfos then EI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDurabilityInfos then DI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end

		if ShowPlayerLoc then PL["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowGameTime then GT["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
	else
		TB["win"]:SetBackColor( Turbine.UI.Color(bcAlpha, bcRed, bcGreen, bcBlue) );
		if ShowMoney then MI["Ctr"]:SetBackColor( Turbine.UI.Color(MbcAlpha, MbcRed, MbcGreen, MbcBlue) ); end
		if ShowDestinyPoints then DP["Ctr"]:SetBackColor( Turbine.UI.Color(DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue) ); end
		if ShowBagInfos then BI["Ctr"]:SetBackColor( Turbine.UI.Color(BbcAlpha, BbcRed, BbcGreen, BbcBlue) ); end
		if ShowPlayerInfos then PI["Ctr"]:SetBackColor( Turbine.UI.Color(PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue) ); end
		if ShowEquipInfos then EI["Ctr"]:SetBackColor( Turbine.UI.Color(EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue) ); end
		if ShowDurabilityInfos then DI["Ctr"]:SetBackColor( Turbine.UI.Color(DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue) ); end

		if ShowPlayerLoc then PL["Ctr"]:SetBackColor( Turbine.UI.Color(PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue) ); end
		if ShowGameTime then GT["Ctr"]:SetBackColor( Turbine.UI.Color(GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue) ); end

		if sFrom == "TitanBar" then TB["win"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "Money" then MI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DP" then DP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "BI" then BI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "PI" then PI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "EI" then EI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DI" then DI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end

		if sFrom == "PL" then PL["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "GT" then GT["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
	end
end
--**^
-- **v Replace control on TitanBar v**
function ReplaceModuleLocation( value )
	if value == "left" then
		--Module starting at left on TitanBar
		local ModuleLeftPos = 0;
		if ShowMoney then MI["Ctr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + MI["Ctr"]:GetWidth(); end
		if ShowDestinyPoints then DP["Ctr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + DP["Ctr"]:GetWidth(); end
		if ShowBagInfos then BI["Ctr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + BI["Ctr"]:GetWidth(); end
		if ShowPlayerInfos then PI["Ctr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + PI["Ctr"]:GetWidth(); end
		if ShowEquipInfos then EI["Ctr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + EI["Ctr"]:GetWidth(); end
		if ShowDurabilityInfos then DI["Ctr"]:SetPosition( ModuleLeftPos, 0 ); ModuleLeftPos = ModuleLeftPos + DI["Ctr"]:GetWidth(); end
	elseif value == "right" then
		--Module starting at right on TitanBar
		local ModuleRightPos = TB["win"]:GetWidth();
		if ShowGameTime then GT["Ctr"]:SetPosition( ModuleRightPos - GT["Ctr"]:GetWidth(), 0 ); ModuleRightPos = GT["Ctr"]:GetLeft(); end
		if ShowPlayerLoc then PL["Ctr"]:SetPosition( ModuleRightPos - PL["Ctr"]:GetWidth(), 0 ); ModuleRightPos = PL["Ctr"]:GetLeft(); end
	elseif value == "all" then
		ReplaceModuleLocation( "left" );
		ReplaceModuleLocation( "right" );
	end
end
--**^
-- **v Set background color v**
function SetBackgroundColor()
	if frmBG then wBackground:Close(); end
	import (AppDirD.."background"); -- LUA background file
	frmBackground();
	_G.sFromCtr = "TitanBar";
end
--**^
-- **v Reset background color v**
function ResetBackgroundColor()
	bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3;
	TB["win"]:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	SaveSettings();
	_G.sFromCtr = "TitanBar";
end
--**^
-- **v Change TitanBar language v**
function ChangeTitanBarLanguage()
	SaveSettings();
	ReloadTitanBar();
end
--**^
-- **v Show Shell Command window v**
function HelpInfo()
	if frmSC then
		wShellCmd:Close();
	else
		import(AppDirD.."shellcmd"); -- LUA shell command file
		frmShellCmd();
	end
end
-- **^
function ReloadControl( value )
	if value == "this" then
		if _G.sFromCtr == "Money" then UpdateMoney(); end
		if _G.sFromCtr == "DP" then UpdateDestinyPoints(); end
		if _G.sFromCtr == "BI" then UpdateBackpackInfos(); end
		if _G.sFromCtr == "PI" then UpdatePlayersInfos(); end
		if _G.sFromCtr == "EI" then UpdateEquipsInfos(); end
		if _G.sFromCtr == "DI" then UpdateDurabilityInfos(); end

		if _G.sFromCtr == "PL" then UpdatePlayerLoc(PLoc); end
		if _G.sFromCtr == "GT" then UpdateGameTime(); end
	elseif value == "ctr" then
		if ShowMoney then UpdateMoney(); end
		if ShowDestinyPoints then UpdateDestinyPoints(); end
		if ShowBagInfos then UpdateBackpackInfos(); end
		if ShowPlayerInfos then UpdatePlayersInfos(); end
		if ShowEquipInfos then UpdateEquipsInfos(); end
		if ShowDurabilityInfos then UpdateDurabilityInfos(); end

		if ShowPlayerLoc then UpdatePlayerLoc(); end
		if ShowGameTime then UpdateGameTime(); end
	end
end

function LoadEquipmentTable()
	EquipSlots = {
		["Earring1"] = Turbine.Gameplay.Equipment.Earring1; --no 13
		["Earring2"] = Turbine.Gameplay.Equipment.Earring2; --no 14
		["Necklace"] = Turbine.Gameplay.Equipment.Necklace; --no 10
		["Pocket"] = Turbine.Gameplay.Equipment.Pocket; --no 15
		["Bracelet1"] = Turbine.Gameplay.Equipment.Bracelet1; --no 8
		["Bracelet2"] = Turbine.Gameplay.Equipment.Bracelet2; --no 9
		["Ring1"] = Turbine.Gameplay.Equipment.Ring1; --no 11
		["Ring2"] = Turbine.Gameplay.Equipment.Ring2; --no 12
		["Head"] = Turbine.Gameplay.Equipment.Head; --no 1
		["Shoulder"] = Turbine.Gameplay.Equipment.Shoulder; --no 6
		["Back"] = Turbine.Gameplay.Equipment.Back; --no 7
		["Chest"] = Turbine.Gameplay.Equipment.Chest; --no 2
		["Gloves"] = Turbine.Gameplay.Equipment.Gloves; --no 4
		["Legs"] = Turbine.Gameplay.Equipment.Legs; --no 3
		["Boots"] = Turbine.Gameplay.Equipment.Boots; --no 5
		["PrimaryWeapon"] = Turbine.Gameplay.Equipment.PrimaryWeapon; --no 16
		["SecondaryWeapon"] = Turbine.Gameplay.Equipment.SecondaryWeapon; --no 17
		["RangedWeapon"] = Turbine.Gameplay.Equipment.RangedWeapon; --no 18
		["Class"] = Turbine.Gameplay.Equipment.Class; --no 20
		["CraftTool"] = Turbine.Gameplay.Equipment.CraftTool; --no 19
	};

	Slots = {"Head", "Earring1", "Earring2", "Necklace", "Shoulder", "Back", "Chest", "Bracelet1", "Bracelet2",
		"Ring1", "Ring2", "Gloves", "Legs", "Boots", "Pocket", "PrimaryWeapon", "SecondaryWeapon", "RangedWeapon",
		"CraftTool", "Class"};
end


-- For debug purpose
function ShowTableContent(table)
	for k,v in pairs(table) do
		write("key:"..tostring(k)..", value:"..tostring(v));
	end
end