-- functionsCtr.lua
-- Written By Habna


function ImportCtr( value )
	if value == "MI" then --Money Infos
		import (AppCtrD.."MoneyInfos");
		PlayerAtt = Player:GetAttributes();
		TB["win"].moneyChangedHandler = AddCallback(PlayerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		UpdateMoney();
	elseif value == "DP" then --Destiny Points
		import (AppCtrD.."DestinyPoints");
		PlayerAtt = Player:GetAttributes();
		TB["win"].dpChangedHandler = AddCallback(PlayerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		UpdateDestinyPoints();
	elseif value == "BI" then --Backpack Infos
		import (AppCtrD.."BagInfos");
		Backpack = Player:GetBackpack();
		TB["win"].iaHandler = AddCallback(Backpack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		TB["win"].irHandler = AddCallback(Backpack, "ItemRemoved", function(sender, args) ItemRemovedTimer:SetWantsUpdates( true ); end);
		UpdateBackpackInfos();
	elseif value == "PI" then --Player Infos
		import (AppCtrD.."PlayerInfos");
		TB["win"].levelChangedHandler = AddCallback(Player, "LevelChanged", function(sender, args) PI["Lvl"]:SetText( Player:GetLevel() ); end);
		TB["win"].nameChangedHandler = AddCallback(Player, "NameChanged", function(sender, args) PI["Name"]:SetText( Player:GetName() ); end);
		UpdatePlayersInfos();
	elseif value == "DI" then --Durability Infos
		--itemEquipHandler = {};
		import (AppCtrD.."DurabilityInfos");
		UpdateDurabilityInfos();
	elseif value == "EI" then --Equipment Infos
		import (AppCtrD.."EquipInfos");
		TB["win"].ieHandler = AddCallback(PlayerEquipment, "ItemEquipped", function(sender, args) UpdateEquipsInfos(); end);
		TB["win"].iueHandler = AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) ItemUnEquippedTimer:SetWantsUpdates( true ); end);
		UpdateEquipsInfos();
	elseif value == "PL" then --Player Location
		import (AppCtrD.."PlayerLoc");
		TB["win"].ChatReceivedHandler = AddCallback(
		Turbine.Chat, "Received", function(sender, args)
			sMess = args.Message;

			----                1111111111222222222233333333 
			----       1234567890123456789012345678901234567
			--sMess = "Entered the Bree-town - Trade channel";
			if GLocale == "en" then sE, sC, iE = "Entered", "-%s", 13;
			elseif GLocale == "fr" then sE, sC, iE = "Canal", "-%s", 7;
			elseif GLocale == "de" then sE, sC, iE = "Kanal", "-%s", 13; end

			local bFound = string.find(sMess, sE, 1);
			if bFound ~= nil then
				local iLoc = string.find(sMess, sC, 1);
				if iLoc ~= nil then
					-- Extract Location from args.Message
					local PLoc = string.sub( sMess, iE, iLoc - 1 );
					UpdatePlayerLoc(PLoc);
					ReplaceModuleLocation( "right" );
				end
			end
		end);

		PLoc = L["PLMsg"];
		UpdatePlayerLoc(PLoc);
	elseif value == "GT" then --Game Time
		import (AppCtrD.."GameTime");
		--PlayerTime = Turbine.Engine.GetDate();
		--TB["win"].gtmChangedHandler = AddCallback(PlayerTime, "MinuteChanged", function(sender, args) UpdateGameTime(); end);
		UpdateGameTime();
	end
end

function GetEquipmentInfos()
	LoadEquipmentTable();

	PlayerEquipment = Player:GetEquipment();
	itemEquipHandler = {};
	--itemEquipHandler, ItemEquippedHandler, ItemUnequippedHandler = {}, {}, {};
	itemEquip = {};
	itemsTotDurability, itemTotScore, numItems = 0, 0, 0;
	
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item Name, WearState, Quality & Durability
		if PlayerEquipItem ~= nil then
			itemEquip[i].Name = PlayerEquipItem:GetName();
			itemEquip[i].Quality = PlayerEquipItem:GetQuality();
			itemEquip[i].Durability = PlayerEquipItem:GetDurability();
			itemEquip[i].Item = true;

			WearState = PlayerEquipItem:GetWearState();
			itemEquip[i].WearState = WearState
			if WearState ~= 0 then numItems = numItems + 1; end -- Undefined item must not be count (Pocket item are as Undefined Wear State, they are indestructible)

			if itemEquipHandler[i] == nil then itemEquipHandler[i] = AddCallback(PlayerEquipItem, "WearStateChanged", function(sender, args) ChangeWearState(i); end); end
			-- Unable to know witch item was removed/added at this time
			--if ItemEquippedHandler[i] == nil then ItemEquippedHandler[i] = AddCallback(PlayerEquipment, "ItemEquipped", function(sender, args) ChangeItem(i, "add"); end); end
			--if ItemUnequippedHandler[i] == nil then ItemUnequippedHandler[i] = AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) ChangeItem(i, "remove"); end); end
		else
			itemEquip[i].Name = "zEmpty";
			itemEquip[i].WearState = 0;
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
			itemEquip[i].Item = false;
		end
	end
end

function CalculateAllItemsDurability()
	local itemDurability = 0;
	itemsTotDurability = 0;

	for i = 1, 20 do
		-- Item Wear State
		if itemEquip[i].WearState == 0 then itemDurability = 0; end -- undefined
		if itemEquip[i].WearState == 2 then itemDurability = 100; end -- Pristine / parfait
		if itemEquip[i].WearState == 4 then itemDurability = 75; end -- Worn / us
		if itemEquip[i].WearState == 1 then itemDurability = 50; end -- Damaged / endommag
		if itemEquip[i].WearState == 3 then itemDurability = 0; end -- Broken / cass

		itemEquip[i].ItemDurPts = itemDurability;
		itemsTotDurability = itemsTotDurability + itemDurability;
	end

	itemsTotDurability = itemsTotDurability / numItems;
end

function CalculateAllItemsScore()
	local itemScore = 0;
	itemTotScore = 0;

	for i = 1, 20 do
		-- Item Score from it's Quality & Durability
		if itemEquip[i].Quality == 5 then itemScore = 50; end -- Common
		if itemEquip[i].Quality == 4 then itemScore = 100; end -- Uncommon
		if itemEquip[i].Quality == 3 then itemScore = 150; end -- Incomparable
		if itemEquip[i].Quality == 2 then itemScore = 200; end -- Rare
		if itemEquip[i].Quality == 1 then itemScore = 250; end -- Legendary
		if itemEquip[i].Quality == 0 then itemScore = 0; end -- undefined
		
		if itemEquip[i].Durability == 0 then itemScore = itemScore + 0; end -- undefined
		if itemEquip[i].Durability == 7 then itemScore = itemScore + 5; end -- Weak / Faible
		if itemEquip[i].Durability == 1 then itemScore = itemScore + 10; end -- Substantial
		if itemEquip[i].Durability == 2 then itemScore = itemScore + 20; end -- Brittle / Fragile
		if itemEquip[i].Durability == 3 then itemScore = itemScore + 30; end -- Normal
		if itemEquip[i].Durability == 4 then itemScore = itemScore + 40; end -- Tought / Robuste
		if itemEquip[i].Durability == 5 then itemScore = itemScore + 50; end -- Flimsy / Fragile ??
		if itemEquip[i].Durability == 6 then itemScore = itemScore + 60; end -- Indestructible
		
		itemEquip[i].ItemPts = itemScore;
		itemTotScore = itemTotScore + itemScore;
	end
end