-- functionsMenu.lua
-- Written By Habna


--**v Functions for the menu v**
--**v Unload TitanBar v**
function UnloadTitanBar()
	--write( "TitanBar: Unloaded" );
	Turbine.PluginManager.LoadPlugin( 'TitanBar Unloader' );
	--Turbine.PluginManager.UnloadScriptState( 'TitanBar' );
end
--**^
--**v Reload TitanBar v**
function ReloadTitanBar()
	--write( "TitanBar: Reloaded" );
	Turbine.PluginManager.LoadPlugin( 'TitanBar Reloader' );
	--UnloadTitanBar();
	--Turbine.PluginManager.LoadPlugin( 'TitanBar' );
end
--**^
-- **v Show/Hide Money v**
function ShowHideMoney()
	ShowMoney = not ShowMoney;
	SaveSettings();
	if ShowMoney then
		--write( "TitanBar: Showing money");
		ImportCtr( "MI" );
		MI["Ctr"]:SetBackColor( Turbine.UI.Color( MbcAlpha, MbcRed, MbcGreen, MbcBlue ) );
	else
		--write( "TitanBar: Hiding money");
		RemoveCallback(PlayerAtt, "MoneyChanged", TB["win"].moneyChangedHandler);
	end
	MI["Ctr"]:SetVisible( ShowMoney );
	ReplaceModuleLocation( "left" );
end
-- **^
-- **v Show/Hide Destiny Points v**
function ShowHideDestinyPoints()
	ShowDestinyPoints = not ShowDestinyPoints;
	SaveSettings();
	if ShowDestinyPoints then
		--write( "TitanBar: Showing Destiny Points");
		ImportCtr( "DP" );
		DP["Ctr"]:SetBackColor( Turbine.UI.Color( DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue ) );
	else
		--write( "TitanBar: Hiding Destiny Points");
		RemoveCallback(PlayerAtt, "DestinyPointsChanged", TB["win"].dpChangedHandler);
	end
	DP["Ctr"]:SetVisible( ShowDestinyPoints );
	ReplaceModuleLocation( "left" );
end
-- **^
-- **v Show/Hide Backpack Infos v**
function ShowHideBackpackInfos()
	ShowBagInfos = not ShowBagInfos;
	SaveSettings();
	if ShowBagInfos then
		--write( "TitanBar: Showing backpack infos");
		ImportCtr( "BI" );
		BI["Ctr"]:SetBackColor( Turbine.UI.Color( BbcAlpha, BbcRed, BbcGreen, BbcBlue ) );
	else
		--write( "TitanBar: Hiding backpack infos");
		RemoveCallback(Backpack, "ItemAdded", TB["win"].iaHandler);
		RemoveCallback(Backpack, "ItemRemoved", TB["win"].irHandler);
	end
	BI["Ctr"]:SetVisible( ShowBagInfos );
	ReplaceModuleLocation( "left" );
end
--**^
-- **v Show/Hide Backpack Infos v**
function ShowHidePlayerInfos()
	ShowPlayerInfos = not ShowPlayerInfos;
	SaveSettings();
	if ShowPlayerInfos then
		--write( "TitanBar: Showing player infos");
		ImportCtr( "PI" );
		PI["Ctr"]:SetBackColor( Turbine.UI.Color( PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue ) );
	else
		--write( "TitanBar: Hiding player infos");
		RemoveCallback(Player, "LevelChanged", TB["win"].levelChangedHandler);
		RemoveCallback(Player, "NameChanged", TB["win"].nameChangedHandler);
	end
	PI["Ctr"]:SetVisible( ShowPlayerInfos );
	ReplaceModuleLocation( "left" );
end
--**^
-- **v Show/Hide equipment Infos v**
function ShowHideEquipInfos()
	ShowEquipInfos = not ShowEquipInfos;
	SaveSettings();
	if ShowEquipInfos then
		--write( "TitanBar: Showing equipment infos");
		GetEquipmentInfos();
		ImportCtr( "EI" );
		EI["Ctr"]:SetBackColor( Turbine.UI.Color( EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue ) );
	else
		--write( "TitanBar: Hiding equipment infos");
		RemoveCallback(PlayerEquipment, "ItemEquipped", TB["win"].ieHandler);
		RemoveCallback(PlayerEquipment, "ItemUnequipped", TB["win"].iueHandler);
	end
	EI["Ctr"]:SetVisible( ShowEquipInfos );
	ReplaceModuleLocation( "left" );
end
--**^
-- **v Show/Hide durability Infos v**
function ShowHideDurabilityInfos()
	ShowDurabilityInfos = not ShowDurabilityInfos;
	SaveSettings();
	if ShowDurabilityInfos then
		--write( "TitanBar: Showing durability infos");
		GetEquipmentInfos();
		ImportCtr( "DI" );
		DI["Ctr"]:SetBackColor( Turbine.UI.Color( DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue ) );
	else
		--write( "TitanBar: Hiding durability infos");
		
	end
	DI["Ctr"]:SetVisible( ShowDurabilityInfos );
	ReplaceModuleLocation( "left" );
end
--**^


-- **v Show/Hide Player Location v**
function ShowHidePlayerLoc()
	ShowPlayerLoc = not ShowPlayerLoc;
	SaveSettings();
	if ShowPlayerLoc then
		ImportCtr( "PL" );
		PL["Ctr"]:SetBackColor( Turbine.UI.Color( PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue ) );
	else
		--write( "TitanBar: Hiding player location");
		RemoveCallback(Turbine.Chat, "Received", TB["win"].ChatReceivedHandler);
	end
	PL["Ctr"]:SetVisible( ShowPlayerLoc );
	ReplaceModuleLocation( "right" );
end
--**^
-- **v Show/Hide Time v**
function ShowHideGameTime()
	ShowGameTime = not ShowGameTime;
	SaveSettings();
	if ShowGameTime then
		--write( "TitanBar: Showing time");
		ImportCtr( "GT" );
		GT["Ctr"]:SetBackColor( Turbine.UI.Color( GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue ) );
	else
		--write( "TitanBar: Hiding time");
		
	end
	GT["Ctr"]:SetVisible( ShowGameTime );
	ReplaceModuleLocation( "right" );
end
--**^