-- menu.lua
-- Written By Habna


-- Locale menu
local LocMenu = Turbine.UI.MenuItem( L["MCL"] );
LocMenu.Items = LocMenu:GetItems();

local LocItems1 = Turbine.UI.MenuItem( L["MCLen"] );
LocItems1:SetChecked( false );	
if TBLocale == "en" then
	LocItems1:SetChecked( true );
	LocItems1.Click = function( sender, args )
		TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos);
	end
else
	LocItems1.Click = function( sender, args )
		TBLocale = "en";
		ChangeTitanBarLanguage();
	end
end
LocMenu.Items:Add( LocItems1 );

local LocItems2 = Turbine.UI.MenuItem( L["MCLfr"] );
LocItems2:SetChecked( false );
if TBLocale == "fr" then
	LocItems2:SetChecked( true );
	LocItems2.Click = function( sender, args )
		TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos);
	end
else
	LocItems2.Click = function( sender, args )
		TBLocale = "fr";
		ChangeTitanBarLanguage();
	end
end
LocMenu.Items:Add( LocItems2 );

LocItems3 = Turbine.UI.MenuItem( L["MCLde"] );
LocItems3:SetChecked( false );
if TBLocale == "de" then
	LocItems3:SetChecked( true );
	LocItems3.Click = function( sender, args )
		TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos);
	end
else
	LocItems3.Click = function( sender, args )
		TBLocale = "de";
		ChangeTitanBarLanguage();
	end
end
LocMenu.Items:Add( LocItems3 );


-- Reset back color of... menu
local RBCMenu = Turbine.UI.MenuItem( L["MCRBG"] );
RBCMenu.Items = RBCMenu:GetItems();

local RBCMenu1 = Turbine.UI.MenuItem( L["MCABTTB"] );
RBCMenu1.Click = function( sender, args ) ResetBGColor("TitanBar"); end
RBCMenu.Items:Add( RBCMenu1 );

local RBCMenu2 = Turbine.UI.MenuItem( L["MCABTA"] );
RBCMenu2.Click = function( sender, args ) ResetBGColor("all"); end
RBCMenu.Items:Add( RBCMenu2 );


--- Main menu
TitanBarMenu = Turbine.UI.ContextMenu();
TitanBarMenu.items = TitanBarMenu:GetItems();

local opt_line = Turbine.UI.MenuItem("---------------------------------------------", false);
local opt_empty = Turbine.UI.MenuItem("", false);

opt_Money = Turbine.UI.MenuItem(L["MBag"]);
opt_Money:SetChecked( ShowMoney );
opt_Money.Click = function( sender, args ) ShowHideMoney(); opt_Money:SetChecked( not opt_Money:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_DP = Turbine.UI.MenuItem(L["MDP"]);
opt_DP:SetChecked( ShowDestinyPoints );
opt_DP.Click = function( sender, args ) ShowHideDestinyPoints(); opt_DP:SetChecked( not opt_DP:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_BI = Turbine.UI.MenuItem(L["MBI"]);
opt_BI:SetChecked( ShowBagInfos );
opt_BI.Click = function( sender, args ) ShowHideBackpackInfos(); opt_BI:SetChecked( not opt_BI:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_PI = Turbine.UI.MenuItem(L["MPI"]);
opt_PI:SetChecked( ShowPlayerInfos );
opt_PI.Click = function( sender, args ) ShowHidePlayerInfos(); opt_PI:SetChecked( not opt_PI:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_EI = Turbine.UI.MenuItem(L["MEI"]);
opt_EI:SetChecked( ShowEquipInfos );
opt_EI.Click = function( sender, args )	ShowHideEquipInfos(); opt_EI:SetChecked( not opt_EI:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_DI = Turbine.UI.MenuItem(L["MDI"]);
opt_DI:SetChecked( ShowDurabilityInfos );
opt_DI.Click = function( sender, args )	ShowHideDurabilityInfos(); opt_DI:SetChecked( not opt_DI:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_PL = Turbine.UI.MenuItem(L["MPL"]);
opt_PL:SetChecked( ShowPlayerLoc );
opt_PL.Click = function( sender, args ) ShowHidePlayerLoc(); opt_PL:SetChecked( not opt_PL:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

opt_GT = Turbine.UI.MenuItem(L["MGT"]);
opt_GT:SetChecked( ShowGameTime );
opt_GT.Click = function( sender, args ) ShowHideGameTime(); opt_GT:SetChecked( not opt_GT:IsChecked() ); TitanBarMenu:ShowMenuAt(mouseXPos, mouseYPos); end

local opt_warn1 = Turbine.UI.MenuItem(L["MWarn1"], false);
local opt_warn2 = Turbine.UI.MenuItem(L["MWarn2"], false);

opt_shellcmd = Turbine.UI.MenuItem(L["MSC"]);
opt_shellcmd.Click = function( sender, args ) HelpInfo(); end

local opt_ResetAllSet = Turbine.UI.MenuItem(L["MRA"]);
opt_ResetAllSet.Click = function( sender, args ) ResetSettings(); end

local opt_unload = Turbine.UI.MenuItem(L["MUTB"] .. Version);
opt_unload.Click = function( sender, args ) UnloadTitanBar(); end

local opt_reload = Turbine.UI.MenuItem(L["MRTB"] .. Version);
opt_reload.Click = function( sender, args ) ReloadTitanBar(); end

option_backcolor = Turbine.UI.MenuItem(L["MBG"]);
option_backcolor.Click = function( sender, args ) SetBackgroundColor(); option_backcolor:SetEnabled( false ); end

-- Debug purpose
option_replacectr = Turbine.UI.MenuItem( "Replace all control");
option_replacectr.Click = function( sender, args ) ReplaceModuleLocation( "all" ); end


TitanBarMenu.items:Add(opt_Money);
TitanBarMenu.items:Add(opt_DP);
TitanBarMenu.items:Add(opt_BI);
TitanBarMenu.items:Add(opt_PI);
if PlayerAlign == 1 then TitanBarMenu.items:Add(opt_EI); end -- only show if in Free People mode
if PlayerAlign == 1 then TitanBarMenu.items:Add(opt_DI); end -- only show if in Free People mode
TitanBarMenu.items:Add(opt_PL);
TitanBarMenu.items:Add(opt_GT);
TitanBarMenu.items:Add(opt_line);
TitanBarMenu.items:Add(opt_warn1);
TitanBarMenu.items:Add(opt_warn2);
TitanBarMenu.items:Add(opt_line);
TitanBarMenu.items:Add(option_backcolor);
TitanBarMenu.items:Add(RBCMenu);
TitanBarMenu.items:Add(opt_empty);
TitanBarMenu.items:Add(LocMenu);
TitanBarMenu.items:Add(opt_empty);
--TitanBarMenu.items:Add(option_replacectr); -- Debug purpose
TitanBarMenu.items:Add(opt_shellcmd);
TitanBarMenu.items:Add(opt_ResetAllSet);
TitanBarMenu.items:Add(opt_empty);
TitanBarMenu.items:Add(opt_unload);
TitanBarMenu.items:Add(opt_reload);