-- settings.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	if GLocale == "de" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsDE" ); end
	if GLocale == "en" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsEN" ); end
	if GLocale == "fr" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsFR" ); end
	
	if settings == nil then
		TBLocale = GLocale;
		bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for TitanBar
		MbcAlpha, MbcRed, MbcGreen, MbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Money Control
		DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Destiny points Control
		BbcAlpha, BbcRed, BbcGreen, BbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Bag Control
		PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Player infos Control
		EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Equipement infos Control
		DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Durability infos Control

		PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Player Location Control
		GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Game time Control
		ShowMoney, ShowDestinyPoints, ShowBagInfos, ShowPlayerInfos, ShowEquipInfos, ShowDurabilityInfos, ShowPlayerLoc, ShowGameTime = false, false, true, true, true, true, true, true;
		SaveSettings();
	end

	TBLocale = settings.Language;
	--write(tostring(AppLocaleD..TBLocale));
	import (AppLocaleD..TBLocale);

	if settings.BackColor == nil then
		settings.BackColor = {};
		settings.BackColor.A = string.format("%.3f", 0.3);
		settings.BackColor.R = string.format("%.3f", 0.3);
		settings.BackColor.G = string.format("%.3f", 0.3);
		settings.BackColor.B = string.format("%.3f", 0.3);
	end
	bcAlpha = tonumber(settings.BackColor.A);
	bcRed = tonumber(settings.BackColor.R);
	bcGreen = tonumber(settings.BackColor.G);
	bcBlue = tonumber(settings.BackColor.B);

	if settings.Show == nil then
		settings.Show = {};
	end

	if settings.Show.Money == nil then
		settings.Show.Money = {};
		settings.Show.Money.V = false;
		settings.Show.Money.A = string.format("%.3f", 0.3);
		settings.Show.Money.R = string.format("%.3f", 0.3);
		settings.Show.Money.G = string.format("%.3f", 0.3);
		settings.Show.Money.B = string.format("%.3f", 0.3);
	end
	ShowMoney = settings.Show.Money.V;
	MbcAlpha = tonumber(settings.Show.Money.A);
	MbcRed = tonumber(settings.Show.Money.R);
	MbcGreen = tonumber(settings.Show.Money.G);
	MbcBlue = tonumber(settings.Show.Money.B);

	if settings.Show.DestinyPoints == nil then
		settings.Show.DestinyPoints = {};
		settings.Show.DestinyPoints.V = false;
		settings.Show.DestinyPoints.A = string.format("%.3f", 0.3);
		settings.Show.DestinyPoints.R = string.format("%.3f", 0.3);
		settings.Show.DestinyPoints.G = string.format("%.3f", 0.3);
		settings.Show.DestinyPoints.B = string.format("%.3f", 0.3);
	end
	ShowDestinyPoints = settings.Show.DestinyPoints.V;
	DPbcAlpha = tonumber(settings.Show.DestinyPoints.A);
	DPbcRed = tonumber(settings.Show.DestinyPoints.R);
	DPbcGreen = tonumber(settings.Show.DestinyPoints.G);
	DPbcBlue = tonumber(settings.Show.DestinyPoints.B);

	if settings.Show.BagInfos == nil then
		settings.Show.BagInfos = {};
		settings.Show.BagInfos.V = true;
		settings.Show.BagInfos.A = string.format("%.3f", 0.3);
		settings.Show.BagInfos.R = string.format("%.3f", 0.3);
		settings.Show.BagInfos.G = string.format("%.3f", 0.3);
		settings.Show.BagInfos.B = string.format("%.3f", 0.3);
	end
	ShowBagInfos = settings.Show.BagInfos.V;
	BbcAlpha = tonumber(settings.Show.BagInfos.A);
	BbcRed = tonumber(settings.Show.BagInfos.R);
	BbcGreen = tonumber(settings.Show.BagInfos.G);
	BbcBlue = tonumber(settings.Show.BagInfos.B);

	if settings.Show.PlayerInfos == nil then
		settings.Show.PlayerInfos = {};
		settings.Show.PlayerInfos.V = true;
		settings.Show.PlayerInfos.A = string.format("%.3f", 0.3);
		settings.Show.PlayerInfos.R = string.format("%.3f", 0.3);
		settings.Show.PlayerInfos.G = string.format("%.3f", 0.3);
		settings.Show.PlayerInfos.B = string.format("%.3f", 0.3);
	end
	ShowPlayerInfos = settings.Show.PlayerInfos.V;
	PIbcAlpha = tonumber(settings.Show.PlayerInfos.A);
	PIbcRed = tonumber(settings.Show.PlayerInfos.R);
	PIbcGreen = tonumber(settings.Show.PlayerInfos.G);
	PIbcBlue = tonumber(settings.Show.PlayerInfos.B);

	if settings.Show.EquipInfos == nil then
		settings.Show.EquipInfos = {};
		settings.Show.EquipInfos.V = true;
		settings.Show.EquipInfos.A = string.format("%.3f", 0.3);
		settings.Show.EquipInfos.R = string.format("%.3f", 0.3);
		settings.Show.EquipInfos.G = string.format("%.3f", 0.3);
		settings.Show.EquipInfos.B = string.format("%.3f", 0.3);
	end
	ShowEquipInfos = settings.Show.EquipInfos.V;
	EIbcAlpha = tonumber(settings.Show.EquipInfos.A);
	EIbcRed = tonumber(settings.Show.EquipInfos.R);
	EIbcGreen = tonumber(settings.Show.EquipInfos.G);
	EIbcBlue = tonumber(settings.Show.EquipInfos.B);

	if settings.Show.DurabilityInfos == nil then
		settings.Show.DurabilityInfos = {};
		settings.Show.DurabilityInfos.V = true;
		settings.Show.DurabilityInfos.A = string.format("%.3f", 0.3);
		settings.Show.DurabilityInfos.R = string.format("%.3f", 0.3);
		settings.Show.DurabilityInfos.G = string.format("%.3f", 0.3);
		settings.Show.DurabilityInfos.B = string.format("%.3f", 0.3);
	end
	ShowDurabilityInfos = settings.Show.DurabilityInfos.V;
	DIbcAlpha = tonumber(settings.Show.DurabilityInfos.A);
	DIbcRed = tonumber(settings.Show.DurabilityInfos.R);
	DIbcGreen = tonumber(settings.Show.DurabilityInfos.G);
	DIbcBlue = tonumber(settings.Show.DurabilityInfos.B);


	if settings.Show.PlayerLoc == nil then
		settings.Show.PlayerLoc = {};
		settings.Show.PlayerLoc.V = true;
		settings.Show.PlayerLoc.A = string.format("%.3f", 0.3);
		settings.Show.PlayerLoc.R = string.format("%.3f", 0.3);
		settings.Show.PlayerLoc.G = string.format("%.3f", 0.3);
		settings.Show.PlayerLoc.B = string.format("%.3f", 0.3);
	end
	ShowPlayerLoc = settings.Show.PlayerLoc.V;
	PLbcAlpha = tonumber(settings.Show.PlayerLoc.A);
	PLbcRed = tonumber(settings.Show.PlayerLoc.R);
	PLbcGreen = tonumber(settings.Show.PlayerLoc.G);
	PLbcBlue = tonumber(settings.Show.PlayerLoc.B);

	if settings.Show.GameTime == nil then
		settings.Show.GameTime = {};
		settings.Show.GameTime.V = true;
		settings.Show.GameTime.A = string.format("%.3f", 0.3);
		settings.Show.GameTime.R = string.format("%.3f", 0.3);
		settings.Show.GameTime.G = string.format("%.3f", 0.3);
		settings.Show.GameTime.B = string.format("%.3f", 0.3);
	end
	ShowGameTime = settings.Show.GameTime.V;
	GTbcAlpha = tonumber(settings.Show.GameTime.A);
	GTbcRed = tonumber(settings.Show.GameTime.R);
	GTbcGreen = tonumber(settings.Show.GameTime.G);
	GTbcBlue = tonumber(settings.Show.GameTime.B);

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsDE", settings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsEN", settings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsFR", settings ); end
end
-- **^

-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;
	settings.Language = TBLocale;

	settings.BackColor = {};
	settings.BackColor.A = string.format("%.3f", bcAlpha);
	settings.BackColor.R = string.format("%.3f", bcRed);
	settings.BackColor.G = string.format("%.3f", bcGreen);
	settings.BackColor.B = string.format("%.3f", bcBlue);
	
	settings.Show = {};
	settings.Show.Money = {};
	settings.Show.Money.V = ShowMoney;
	settings.Show.Money.A = string.format("%.3f", MbcAlpha);
	settings.Show.Money.R = string.format("%.3f", MbcRed);
	settings.Show.Money.G = string.format("%.3f", MbcGreen);
	settings.Show.Money.B = string.format("%.3f", MbcBlue);

	settings.Show.DestinyPoints = {};
	settings.Show.DestinyPoints.V = ShowDestinyPoints;
	settings.Show.DestinyPoints.A = string.format("%.3f", DPbcAlpha);
	settings.Show.DestinyPoints.R = string.format("%.3f", DPbcRed);
	settings.Show.DestinyPoints.G = string.format("%.3f", DPbcGreen);
	settings.Show.DestinyPoints.B = string.format("%.3f", DPbcBlue);

	settings.Show.BagInfos = {};
	settings.Show.BagInfos.V = ShowBagInfos;
	settings.Show.BagInfos.A = string.format("%.3f", BbcAlpha);
	settings.Show.BagInfos.R = string.format("%.3f", BbcRed);
	settings.Show.BagInfos.G = string.format("%.3f", BbcGreen);
	settings.Show.BagInfos.B = string.format("%.3f", BbcBlue);

	settings.Show.PlayerInfos = {};
	settings.Show.PlayerInfos.V = ShowPlayerInfos;
	settings.Show.PlayerInfos.A = string.format("%.3f", PIbcAlpha);
	settings.Show.PlayerInfos.R = string.format("%.3f", PIbcRed);
	settings.Show.PlayerInfos.G = string.format("%.3f", PIbcGreen);
	settings.Show.PlayerInfos.B = string.format("%.3f", PIbcBlue);

	settings.Show.EquipInfos = {};
	settings.Show.EquipInfos.V = ShowEquipInfos;
	settings.Show.EquipInfos.A = string.format("%.3f", EIbcAlpha);
	settings.Show.EquipInfos.R = string.format("%.3f", EIbcRed);
	settings.Show.EquipInfos.G = string.format("%.3f", EIbcGreen);
	settings.Show.EquipInfos.B = string.format("%.3f", EIbcBlue);

	settings.Show.DurabilityInfos = {};
	settings.Show.DurabilityInfos.V = ShowDurabilityInfos;
	settings.Show.DurabilityInfos.A = string.format("%.3f", DIbcAlpha);
	settings.Show.DurabilityInfos.R = string.format("%.3f", DIbcRed);
	settings.Show.DurabilityInfos.G = string.format("%.3f", DIbcGreen);
	settings.Show.DurabilityInfos.B = string.format("%.3f", DIbcBlue);


	settings.Show.PlayerLoc = {};
	settings.Show.PlayerLoc.V = ShowPlayerLoc;
	settings.Show.PlayerLoc.A = string.format("%.3f", PLbcAlpha);
	settings.Show.PlayerLoc.R = string.format("%.3f", PLbcRed);
	settings.Show.PlayerLoc.G = string.format("%.3f", PLbcGreen);
	settings.Show.PlayerLoc.B = string.format("%.3f", PLbcBlue);

	settings.Show.GameTime = {};
	settings.Show.GameTime.V = ShowGameTime;
	settings.Show.GameTime.A = string.format("%.3f", GTbcAlpha);
	settings.Show.GameTime.R = string.format("%.3f", GTbcRed);
	settings.Show.GameTime.G = string.format("%.3f", GTbcGreen);
	settings.Show.GameTime.B = string.format("%.3f", GTbcBlue);

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsDE", settings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsEN", settings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsFR", settings ); end
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	write( L["TBR"] );
	TBLocale = "en";
	ShowMoney, ShowDestinyPoints, ShowBagInfos, ShowPlayerInfos, ShowEquipInfos, ShowDurabilityInfos, ShowPlayerLoc, ShowGameTime  = false, false, true, true, true, true, true, true;

	if GLocale == "en" then tA, tR, tG, tB = 0.3, 0.3, 0.3, 0.3;
	else tA, tR, tG, tB = "0,3", "0,3", "0,3", "0,3"; end

	bcAlpha, bcRed, bcGreen, bcBlue = tA, tR, tG, tB; --Backcolor for TitanBar
	MbcAlpha, MbcRed, MbcGreen, MbcBlue = tA, tR, tG, tB; --Backcolor for Money Control
	DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue = tA, tR, tG, tB; --Backcolor for Destiny points Control
	BbcAlpha, BbcRed, BbcGreen, BbcBlue = tA, tR, tG, tB; --Backcolor for bag Control
	PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue = tA, tR, tG, tB; --Backcolor for Player infos Control
	EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue = tA, tR, tG, tB; --Backcolor for Equipment infos Control
	DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue = tA, tR, tG, tB; --Backcolor for Durability infos Control

	PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue = tA, tR, tG, tB; --Backcolor for Player Location Control
	GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue = tA, tR, tG, tB; --Backcolor for Game time Control

	SaveSettings();
	ReloadTitanBar();
end
-- **^

-- **v Save character wallet infos v**
function SaveCharacterWallet()
	wallet = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarWallet" );
	
	if wallet == nil then wallet = {}; end

	local PN = Player:GetName();
		
	local G = string.format("%.0f", MI["GLbl"]:GetText());
	local S = string.format("%.0f", MI["SLbl"]:GetText());
	local C = string.format("%.0f", MI["CLbl"]:GetText());
	local strData = G .. "/" .. S .. "/" .. C;

	wallet[PN] = strData;

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarWallet", wallet );
end
-- **^